#include "BluetoothSerial.h" //Header File for Serial Bluetooth, will be added by default into Arduino
#include "esp_bt_main.h"
#include "esp_bt_device.h"

char bda_str[18];

bool initBluetooth()
{
  if(!btStart()) {
    Serial.println("Failed to initialize controller");
    return false;
  }
 
  if(esp_bluedroid_init() != ESP_OK) {
    Serial.println("Failed to initialize bluedroid");
    return false;
  }
 
  if(esp_bluedroid_enable() != ESP_OK) {
    Serial.println("Failed to enable bluedroid");
    return false;
  }
  return true;
}

char *bda2str(const uint8_t* bda, char *str, size_t size)
{
  if (bda == NULL || str == NULL || size < 18) {
    return NULL;
  }
  sprintf(str, "%02x:%02x:%02x:%02x:%02x:%02x",
          bda[0], bda[1], bda[2], bda[3], bda[4], bda[5]);
  return str;
} 

BluetoothSerial ESP_BT; //Object for Bluetooth

int incoming;

void setup() {
  initBluetooth();
  Serial.begin(115200); //Start Serial monitor in 115200
  Serial.println("");
  Serial.println("");
  Serial.print("ESP32 bluetooth address: "); //Get and print MAC adress of ESP32
  Serial.println(bda2str(esp_bt_dev_get_address(), bda_str, 18)); 
  ESP_BT.begin("ESP32_LED_Control"); //Name of your Bluetooth Signal
  Serial.println("Bluetooth Device is Ready to Pair");

  pinMode (LED_BUILTIN, OUTPUT); //Specify that LED pin is output
}

void loop() {
  
  if (ESP_BT.available()) //Check if we receive anything from Bluetooth
  {
    incoming = ESP_BT.read(); //Read what we recevive 
    Serial.print("Received:");
    Serial.println(incoming);

    if (incoming == 49) //Send 1
        {
        digitalWrite(LED_BUILTIN, HIGH);
        ESP_BT.println("LED turned OFF");
        }
        
    if (incoming == 48) //Send 0
        {
        digitalWrite(LED_BUILTIN, LOW);
        ESP_BT.println("LED turned ON");
        }     
  }
  delay(20);
}